/* ---------------------------------------------------------------------------
 * Tseng Labs ET6000 framebuffer support
 * ---------------------------------------------------------------------------
 *
 * Copyright (C) 1997, The Linux-GGI Project
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * -----------------------------------------------------------------------
 *
 *   $Log: et6000_graph.c,v $
 *
 * ---------------------------------------------------------------------------
 */

#include <ggi/maintainers.h>
/*#define MAINTAINER      Jim_Ursetto*/
#define DRIVER_NAME	"Tseng Labs ET6000 graphics driver"
#define	DRIVER_REV	"$Revision: 0.00 $"

#define DEBUG_LEVEL	0

/* KGI includes */
#include <asm/io.h>

#include <ggi/module.h>
#include <ggi/ggi_commands.h>

#include "suggest.inc"

/*#include "et6000_mmio.inc"*/

/* KGI module interface */

int kgim_graphics_init(struct kgi_card *card, struct kgi_display *dpy)
{
	return EOK;
}

void kgim_graphics_done(struct kgi_display *dpy)
{
	NOTICE1("ET6000 Graphics Driver removed");
}

int kgim_graphics_check_mode (struct kgi_display *dpy, struct kgi_mode *mode,
			      enum kgi_tm_cmd cmd)
{
	/* !!! Should we check for accel-friendly dimensions here ??? */

/* 4 bit mode may require mmap_setpage_4bit; libggi won't load vendor-IBM-*-4
 * so I can't check till I fix that. */
    
/*      switch (cmd) {
	
	case CMD_PROPOSE:
	  switch (mode->request.graphtype) {
	    case GT_4BIT:
	      mode->mmio = &mm_4bit;
	      break;
	    default:
	  }
	  
      } */
        return EOK;
}

void kgim_graphics_set_mode (struct kgi_display *dpy, struct kgi_mode *mode)
{
}

int kgim_graphics_command (struct kgi_graphic *gr, uint cmd, uint arg)
{ 
	ggi_suggest *sugg;
	const char *name;

	switch (cmd) {
		case GRAPHICS_GETSUGGEST:
		sugg = (ggi_suggest *)(gr->io_buf);
		gr->io_res = gr->io_buf;
		
		if (sugg->id < 0 || sugg->id > 4) {
			return -E(GRAPHICS, BOGUS);
	        }

	        name = sugg_default[gr->dev.mode.graphtype].text[sugg->id];
		if (!name) {
			return -E(GRAPHICS,BOGUS);
		}
      
		strcpy(sugg->name, name);
		sugg->args[0] = 0;
		sugg->id++;	/* Next is RAMDAC */
		if (sugg->id >= 4 || 
		    sugg_default[gr->dev.mode.graphtype].text[sugg->id] == NULL) {
			sugg->id = 0;
		}
		return EOK;
		default:
		    break;
	}
	return -E(GRAPHICS, NOSUP_ALWAYS_MMAP);
}
